; WhatDir
; a program by Androgyne/RtC
; especially for hccc#6
;
; dsol, rien n'est comment, allez voir l'article pour comprendre :)
; voil le batch de compilation...
;
;--- COMP.BAT ---
; echo off
; tasm32 /m /ml whatdir.asm > whatdir.lst
; tlink32 /Tpe /aa /c whatdir,whatdir.exe,,import32.lib,,whatdir.res >> whatdir.lst
; del whatdir.obj
; del whatdir.map
; notepad whatdir.lst
;--- COMP.BAT ---


.386
.model flat, stdcall

include win32.inc


    extrn ExitProcess:proc
    extrn GetModuleHandleA:proc
    extrn DialogBoxParamA:proc
    extrn EndDialog:proc
    extrn LoadIconA:proc
    extrn SendMessageA:proc
    extrn SendDlgItemMessageA:proc
    extrn MessageBoxA:proc

    extrn GetWindowsDirectoryA:proc
    extrn GetSystemDirectoryA:proc
    extrn GetCurrentDirectoryA:proc


MAIN_BOX        equ 301
ABOUT_BOX       equ 302
MY_ICONE        equ 201
BUTTON_ABOUT    equ 101
BUTTON_QUIT     equ 102
ET_WIN          equ 103
ET_SYS          equ 104
ET_CUR          equ 105


.data

h_module        dd 0
win_dir         db MAX_PATH dup(0)
sys_dir         db MAX_PATH dup(0)
cur_dir         db MAX_PATH dup(0)

.code

demo:

    call GetWindowsDirectoryA, offset win_dir, MAX_PATH
    call GetSystemDirectoryA, offset sys_dir, MAX_PATH
    call GetCurrentDirectoryA, MAX_PATH, offset cur_dir

    call GetModuleHandleA, 0
    mov h_module,eax
    call DialogBoxParamA, h_module, MAIN_BOX, 0, offset MyBox, 0

    call ExitProcess, 0


; Main Box procedure

MyBox proc _hwind:DWORD, wmsg:DWORD, wparama:DWORD, lparama:DWORD


    cmp [wmsg],WM_INITDIALOG
    je init_box
    cmp [wmsg],WM_CLOSE
    je kill_box
    cmp [wmsg],WM_DESTROY
    je kill_box
    cmp [wmsg],WM_COMMAND
    je events

    xor eax,eax

    ret

kill_box:
    call EndDialog, _hwind, 0


init_box:
    call LoadIconA, h_module, MY_ICONE
    call SendMessageA, _hwind, WM_SETICON, 0, eax

    call SendDlgItemMessageA, _hwind, ET_WIN, WM_SETTEXT, 0, offset win_dir
    call SendDlgItemMessageA, _hwind, ET_SYS, WM_SETTEXT, 0, offset sys_dir
    call SendDlgItemMessageA, _hwind, ET_CUR, WM_SETTEXT, 0, offset cur_dir

    ret

events:

    cmp [wparama], BUTTON_ABOUT
    je event_about
    cmp [wparama], BUTTON_QUIT
    je kill_box

    ret


event_about:

    call DialogBoxParamA, h_module, ABOUT_BOX, _hwind, offset AboutBox, 0

    ret


MyBox endp

; About Box procedure

AboutBox proc _hwind:DWORD, wmsg:DWORD, wparama:DWORD, lparama:DWORD


    cmp [wmsg],WM_INITDIALOG
    je init_about
    cmp [wmsg],WM_CLOSE
    je kill_about
    cmp [wmsg],WM_DESTROY
    je kill_about

    xor eax,eax

    ret

kill_about:
    call EndDialog, _hwind, 0


init_about:

    call LoadIconA, h_module, MY_ICONE
    call SendMessageA, _hwind, WM_SETICON, 0, eax

    ret

AboutBox endp



end demo